<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<!-- PMR JR 46861's import -->
<%@ page import="java.net.URL" %>
<%@ page import="java.net.MalformedURLException" %>
<%@ page import="com.lombardisoftware.core.config.TWConfiguration" %>
<!-- BEGIN #content -->
<%!

  public String getProtocolFromURL(String url) {
	String protocol = null;
	int i = url.indexOf(":");
	int j = url.indexOf("/");
	if ((i > 0) && ((i < j) || (j == -1))){
		protocol = url.substring(0,i).trim();
	}
	return protocol;
  }
%>  
<% 
	String url = request.getParameter("url"); 
	if (url != null) {
		// PMR JR46861
		// Problem: AppScan is showing a false positive (build 8500) since iframe are isolated from browser.
		//   However, redirection via url is still possible; since no check was done (before this).  This fix
		//   will check the url to make sure it is sanitize to current host and port.  This implementation
		//	 will use a simplistic whitelist (array).  This will allow for future expansion of the logic.
		// Note: When url redirection is requested for host outside of portal; then it replaces url with null
		//   string.  This could be changed to redirect users to an error page.  However, this is not
		//   implemented with this update.  

		try {
			// passURL contains the url being requested (parameter)
			URL passURL = new URL(url);
			String passHost = passURL.getHost();

			// servletURL contains the url for the current WAS server; as specified by 99local.xml and 100custom.xml
			// Note that 99local specify the default port of 9080 for all pages; thus must check via java servlet
			// for secure port (at build 8500, it's 9443).
			URL servletURL = new URL(TWConfiguration.getInstance().getAuthoringEnvironment().getServletPrefix());
			
			// The complete URL without the parameter being passed in
			URL wholeURL = new URL(request.getRequestURL().toString());

			// Simple white list that will contain the values to compare to
			String[] whiteList = {wholeURL.getHost(), servletURL.getHost(), "localhost", "127.0.0.1"};

			// The flag is used so we do not have to re-set url (eg. if true set url = wholeurl)
			boolean isNotValid = true;
			
			// Use the iterator to run through the array
			for(String s : whiteList) {
				if(passHost.equals(s)) {
					isNotValid = false;
					break;	// The break will ensure that if there is a match, then ignore the rest, improves performance
				}				
			}

			if(isNotValid) {
				// If isNotValid is true, then it is not valid, else valid
				url = "";
			}

		} catch (MalformedURLException e) {
			// In the case that the URL being passed in is incorrect; assume malicious and null the string
			url = "";
		}
		// End PMR JR46861
		
		url = url.replace("\"", " ");
		url = url.replace("\'", " ");

		// do not allow inline javascript
		String test = getProtocolFromURL(url);
		if ("javascript".equals(test)) {
			url = "";
		}
	} else {
		url = "";
	}
	String titleParm = request.getParameter("title");
	String titleParmWithoutSingleQuotes;
	if (titleParm != null) {
		titleParm = titleParm.replace("\"", " ");
		titleParmWithoutSingleQuotes = titleParm.replace("\'", " ");
	} else {
		titleParm = "";
		titleParmWithoutSingleQuotes = "";
	}
%>
<div id="startPageButtonDashboards"></div>
<div id="content">
	<div class="content dashboard-content">
		<%-- reportId  2015.107 is My Performance; 2015.106 is My Team Performance; 2015.104 is Process Performance; 2015.105 is PM SLA Overview--%>
		<iframe id="scoreboardFrame" name="scoreboardFrame" src="<%=url%>" title="<%=titleParm%>" scrolling="auto" 
			width="100%" height="100%" frameborder="0" onload='dojo.publish(com.ibm.bpm.social.portal.Topics.DASHBOARD_LOADED, [{ url: "<%=url%>" , title : "<%=titleParmWithoutSingleQuotes%>" }])'>
		</iframe>
	</div>
<br>
<br>
<br>
</div ><!-- END #content -->
